function [ P1, Q1, d ] = distLineLine( o1, dir1, o2, dir2 )
%DISTLINELINE Summary of this function goes here
%   Outputs the shortest distance between 2 lines and the points on the
%   lines corresponding to this distance

syms s t

P = o1 + s*dir1;
Q = o2 + t*dir2;

PQ = P-Q;
eq1 = dot(PQ,dir1);
eq2 = dot(PQ,dir2);

eqSol = solve(eq1,eq2,s,t);

P1 = o1 + eqSol.s*dir1;
Q1 = o2 + eqSol.t*dir2;
d = double(norm(P1-Q1));

end

