function sorted_points = find_correspondence(g)

%gp [numPoints x 5]
c = size(g,1);

x2D = g(:,4);
y2D = g(:,5);

distmat = sqrt( (repmat(x2D, 1, c) - repmat(x2D', c, 1)).^2 + ((repmat(y2D, 1, c) - repmat(y2D', c, 1) )).^2 );
distmat(distmat==0) = Inf;

[mindist, ind] = min(distmat,[], 2);

[~,reference] = max(mindist);

dist_from_reference = distmat(:,reference);
% dist_from_reference(reference) = -1;

% [minss,indd] = sort(dist_from_reference);

sorted_index= -ones(length(g),1);
sorted_index(1)=reference;

for i = 1:length(dist_from_reference)-1
    [min_dist_from_prev, nextindices] = sort(distmat(sorted_index(i),:));
    k = 1;
    while ( sum(nextindices(k) == sorted_index) )
       k = k+1; 
    end
    sorted_index(i+1) = nextindices(k);
    
end


sorted_points = g(sorted_index,:);
% 
% x2D_sorted = sorted_points(:,4);
% y2D_sorted = sorted_points(:,5);

% fs = 20;
% 
% figure;
% subplot(2,1,1);
% scatter(x2D_sorted,y2D_sorted,'MarkerEdgeColor','b','MarkerFaceColor',[0 .5 .5],'LineWidth',0.6);
% for i = 1:length(x2D_sorted)
%    text(x2D_sorted(i)+1, y2D_sorted(i)+1, num2str(i-1), 'fontsize', fs);
% end
% 
% 
% subplot(2,1,2)
% scatter3(sorted_points(:,1), sorted_points(:,2), sorted_points(:,3),'MarkerEdgeColor','b','MarkerFaceColor',[0 .5 .5],'LineWidth',0.6);
% for i = 1:length(sorted_points(:,1))
%    text(sorted_points(i,1)+1, sorted_points(i,2)+1, sorted_points(i,3)+1, num2str(i-1) , 'fontsize', fs);
% end

end


